﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CommonExtensions.ObjectExtensions;
using CommonExtensions.StringExtensions;
using StructureMap;

namespace DBMigrator.Core.DbObjects.Data.Select.From
{
    public class From : IFrom
    {
        public string TableName { get; private set; }
        public IFromTable FromTable { get; private set; }

        public From(IFromTable fromTable)
        {
            if(fromTable.IsNull())
                throw new ArgumentNullException("fromTable");

            FromTable = fromTable;
        }

        public IFromTable Table(string tableName)
        {
            if(tableName.IsBlank())
                throw new ArgumentNullException("tableName");

            TableName = tableName;

            return FromTable;
        }
    }
}
